/*
  sha1pass.cpp
  Copyright (C) 2009 Tomohiro Masubuchi <bucchi@e-ml.jp>

  This file is part of wpa_setting.

  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; If not, see <http://www.gnu.org/licenses/>.
*/

#include <string.h>
#include "sha1pass.h"
#include <qstring.h>

extern "C" {
#include "common.h"
#include "sha1.h"
}

QString SHA1Pass::getEncodedPass(QString const &ssid, QString const &pass)
{
	QString enc_pass = "", hex;
	unsigned char psk[32];
	int i;

	pbkdf2_sha1(pass.ascii(), ssid.ascii(), ssid.length(), 4096, psk, 32);

	for (i = 0; i < 32; i++) {
		hex.sprintf("%02x", psk[i]);
		enc_pass += hex;
	}
	return enc_pass;
}
